<div align='left'>
<p align="right"><font size="1">Updated: 2005-01-03</font></p>
<div>
  <h1 align="center">404 SEF for Mambo 4.5.1</h1>
  <p align="center"><a href="http://sef404.sourceforge.net/">http://sef404.sourceforge.net/</a></p>
</div>
<div>
<h3>Project Summary</h3>
<ul id="summary">
<li style="list-style: none">
	Allows Search Engine Friendly URLS for apache and IIS, returns
	proper 404 status code for missing content, provides logging of 404 errors, and
	creation of special &quot;shortcut&quot; URLs that allow the user to redirection to the
	new URL.</p>

	<p>This package should contain the following files:</p>
		<ul>
		<li>404SEF_cpanel.php</li>
		<li>admin.sef.html.php</li>
		<li>admin.sef.php</li>
		<li>config.sef.php</li>
		<li>index.html</li>
		<li>install.sef.php</li>
		<li>language/english.php</li>
		<li>readme.inc</li>
		<li>sef.class.php</li>
		<li>sef.xml</li>
		<li>toolbar.sef.html.php</li>
		<li>toolbar.sef.php</li>
		<li>uninstall.sef.php</li>
		<li>images/config.png</li>
		<li>images/cut.png</li>
		<li>images/down.png</li>
		<li>images/help.png</li>
		<li>images/info.png</li>
		<li>images/logo.png</li>
		<li>images/logs.png</li>
		<li>images/paypalbutton.png</li>
		<li>images/up.png</li>
		</ul>
	</li>
</li>
<br />
</ul>
</div>
<div>
<h3>Project Documentation</h3>
<ul id="collapsibleList">
	<li><script type="text/javascript">document.writeln('<img id="imgInstall" src="components/com_sef/images/up.png" width="15" height="8" alt="Open list" onClick="toggle(\'imgInstall\',\'install\');">');</script>
		<b>Installation</b>
	</li>
	<li style="list-style: none">
		<ul id="install">
		<li style="list-style: none">
			<ol>
			<li>Upload the zip file to Mambo using the component installer in the usual way.</li>
			<li>For apache, add the following lines to your &quot;.htaccess&quot; file :<br>
			<pre>
##
# @version $Id: readme.inc,v 1.3 2005/02/13 18:03:41 marlboroman_2k Exp $
# @package Mambo_4.5
# @copyright (C) 2000 - 2004 Miro International Pty Ltd
# @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
# Mambo is Free Software
##

#
#  mod_rewrite in use
#
DirectoryIndex index.php

RewriteEngine On

#  for apache on windows you might need to uncomment
#  this Options line
#Options +SymlinksIfOwnerMatch

#  Uncomment following line if your webserver's URL
#  is not directly related to physival file paths.
#  Update YourMamboDirectory (just / for root)

RewriteBase /
#
#  Rules
#

RewriteCond %{REQUEST_FILENAME} !-f
RewriteCond %{REQUEST_FILENAME} !-d
RewriteRule ^(.*) index.php
			</pre></li>
			<li>For IIS, see Configuring IIS..</li>
			<li>Ensure that SEF is enabled in the mambo backend.</li>
			<li>Edit the 404 SEF configuration, Change Enable to yes and save.<br/>
			This is neccessary to ensure the default 404 document gets saved to the mambo database.</li>
			</ol>
		</li>
		<br />
		</ul>
	</li>

	<li><script type="text/javascript">document.writeln('<img id="imgIIS" src="components/com_sef/images/up.png" width="15" height="8" alt="Open list" onClick="toggle(\'imgIIS\',\'iis\');">');</script>
		<b>Configuring IIS</b>
	</li>
	<li style="list-style: none">
		<ul id="iis">
		<li style="list-style: none">
			<ol>
			<li><b>Install ActiveScript</b><br/>After installing PHP, you should download the ActiveScript DLL (php4activescript.dll)
			and place it in the main PHP folder (e.g. C:\php).<br/>
			<br/>After having all the files needed, you must register the DLL on your system.
			To achieve this, open a Command Prompt window (located in the Start Menu). Then
			go to your PHP directory by typing something like cd C:\php. To register the DLL
			just type <pre>regsvr32 php4activescript.dll</pre></li>
			<li><b>Install .NET framework 1.1</b><br/>To the best of my limited knowledge of IIS, this is required for web.config to
			work, so install it<br/><br/></li>
			<li><b>Create/Modify web.config</b><br><br/>
			<font color="red"><b>NOTE: in the example below, mambo is installed in the virtual directory mambo</b></font><br/><br/>
			Create C:\Inetpub\wwwroot\web.config and add the content below:<br>
			<pre>&lt;?xml version=&quot;1.0&quot; encoding=&quot;utf-8&quot;?&gt;
&lt;configuration&gt;
	&lt;system.web&gt;
		&lt;compilation defaultLanguage=&quot;PHP4Script&quot; debug=&quot;true&quot; /&gt;
		&lt;customerrors mode=&quot;On&quot; defaultRedirect=&quot;/mambo/index.php&quot; /&gt;
	&lt;/system.web&gt;
&lt;/configuration&gt;</pre></li>
			<li><b>Configure the Custom Errors</b><br/><br/>
			<font color="red"><b>NOTE: in the example below, mambo is installed in the virtual directory mambo</b></font><pre>
Using the Internet Services Manager, right-click the directory in which mambo is installed.
Select properties >> Custom Error
set the 404 to URL:/mambo/index.php
set the 405 to URL:/mambo/index.php</pre></li>
			</ol>
		</li>
		<br />
		</ul>
	</li>


	<li><script type="text/javascript">document.writeln('<img id="imgUninstall" src="components/com_sef/images/up.png" width="15" height="8" alt="Open list" onClick="toggle(\'imgUninstall\',\'uninstall\');">');</script>
		<b>Uninstall</b>
	</li>
	<li style="list-style: none">
		<ul id="uninstall">
		<li style="list-style: none">
			<ol>
			<li>Uninstall the component using the component unistaller in the usual way.</li>
			<li>For apache, remove the following lines in your &quot;.htaccess&quot; files :<br>
			<pre>
##
# @version $Id: readme.inc,v 1.3 2005/02/13 18:03:41 marlboroman_2k Exp $
# @package Mambo_4.5
# @copyright (C) 2000 - 2004 Miro International Pty Ltd
# @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
# Mambo is Free Software
##

#
#  mod_rewrite in use
#
DirectoryIndex index.php

RewriteEngine On

#  for apache on windows you might need to uncomment
#  this Options line
#Options +SymlinksIfOwnerMatch

#  Uncomment following line if your webserver's URL
#  is not directly related to physival file paths.
#  Update YourMamboDirectory (just / for root)

RewriteBase /
#
#  Rules
#

RewriteCond %{REQUEST_FILENAME} !-f
RewriteCond %{REQUEST_FILENAME} !-d
RewriteRule ^(.*) index.php
			</pre></li>
			<li>For IIS, remove C:\Inetpub\wwwroot\web.config and<br>
			the Custom Errors you created with the Internet Services Manager<br>
			</ol>
		</li>
		<br />
		</ul>
	</li>
</ul>

<script type="text/javascript">
 document.getElementById('collapsibleList').style.listStyle="none"; // remove list markers
 document.getElementById('install').style.display="none"; // collapse list
 document.getElementById('iis').style.display="none"; // collapse list
 document.getElementById('uninstall').style.display="none"; // collapse list
 // this function toggles the status of a list
 function toggle(image,list){
 var listElementStyle=document.getElementById(list).style;
 if (listElementStyle.display=="none"){
 	listElementStyle.display="block"; document.getElementById(image).src="components/com_sef/images/down.png";
 	document.getElementById(image).alt="Close list";
 }else{
 	listElementStyle.display="none";
 	document.getElementById(image).src="components/com_sef/images/up.png";
 	document.getElementById(image).alt="Open list";
 }
}
</script></div>
</div>
<br/>
<p>Copyright &copy; 2004 W.H.Welch<br/>
Distributed under the terms of the GNU General Public License<br/>
This software may be used without warranty provided and these statements are left intact.</p>
